// (C) 2001-2010 Altera Corporation. All rights reserved.
// Your use of Altera Corporation's design tools, logic functions and other 
// software and tools, and its AMPP partner logic functions, and any output 
// files any of the foregoing (including device programming or simulation 
// files), and any associated documentation or information are expressly subject 
// to the terms and conditions of the Altera Program License Subscription 
// Agreement, Altera MegaCore Function License Agreement, or other applicable 
// license agreement, including, without limitation, that your use is for the 
// sole purpose of programming logic devices manufactured by Altera and sold by 
// Altera or its authorized distributors.  Please refer to the applicable 
// agreement for further details.


module sv_10gbaser_rx_ch #(
	parameter output_clock_frequency = "5.15625 GHz",
	parameter ref_clk_freq = "322 Mhz"
)(
	input  wire     rx_digital_rstn,
	input  wire     rx_analog_rstn,
	input  wire     xgmii_tx_clk,        //     xgmii_tx_clk.clk
	input  wire     pll_ref_clk,         //      pll_ref_clk.clk
	output wire     rx_is_lockedtodata,          //        rx_ready0.data
	output wire     rx_is_lockedtoref,
	output wire 	[71:0] xgmii_rx_dc,      //    xgmii_rx_dc_0.data
	input  wire     rx_serial_data,  // rx_serial_data_0.export
	input  wire  	rxclrbercount,
	input  wire  	rxclrerrorblockcount,
	input  wire  	rxprbserrorclr,
	output wire 	pcsstatus,
	output wire 	rxblocklock,
	output wire 	rxhighber,
	output wire 	[ 5:0 ] bercount,
	output wire 	[ 7:0 ] errorblockcount,
	output wire 	[ 15:0 ] randomerrorcount,
	output wire 	 rxfifoempty,
	output wire 	 rxfifopartialempty,
	output wire 	 rxfifopartialfull,
	output wire 	 rxfifofull,
	output wire 	 rxsyncheadererror,
	output wire 	 rxscramblererror
);

wire [39:0] rx_parallel_data;
wire clk_from_rx_pma;
wire [ 63:0 ] rx_dataout;  
wire [ 9:0 ] rx_control;   
wire  rx_data_valid;	
generate
genvar i;
for (i=0; i<8; i=i+1) 
begin: bus_assign
	assign xgmii_rx_dc[9*(i+1)-1 : 9*i] = {rx_control[i], rx_dataout[8*(i+1) -1 : 8*i]};
end 
endgenerate
  
wire fref;
wire clklow;
wire freqlocked_to_cdr;
wire signaldetect_from_pma;


sv_rx_pma #(
	 .bonded_lanes (1),
	 .mode (40),
	 .serial_loopback ("lpbkp_dis"),
	 .channel_number ( 0),
	 .auto_negotiation ( "false"),
	 .cdr_reference_clock_frequency ( ref_clk_freq),
	 .cdr_output_clock_frequency ( output_clock_frequency)
) sv_rm_pma_0( 
	 .rstn (rx_digital_rstn),
	.analogreset(rx_analog_rstn),
	.datain(rx_serial_data),
	.bslip(1'b0),

	.cdr_ref_clk(pll_ref_clk),

	.pciesw(1'b0),

	.dout(rx_parallel_data),
	.clkdivrx(clk_from_rx_pma),

	.clklow(clklow),
	.fref(fref),

	.rx_is_lockedtoref(rx_is_lockedtoref),
	.pfdmodelock(),
	
	.sd(signaldetect_from_pma),
	.freqlock(freqlocked_to_cdr)
	
);

sv_rx_10g_pcs #(
	  .pma_pcs_width ( 40), 			//Valid values: 0..65), all the lanes are bonded
	  .pld_pcs_width ( 64), 			//Valid values: 0..65), all the lanes are bonded
          
	  .prot_mode ( "teng_baser_mode"),		//Valid values: "disable_mode"|"teng_baser_mode"|"interlaken_mode"|"sfis_mode"|"teng_sdi_mode"|"basic_mode"|"test_prbs_mode"|"test_prp_mode"
	//.Gerabox_related
	  .gearbox_sel_mode ( "internal"),	//Valid values: INTERNAL|EXTERNAL
	  .gearbox_lpbk_mode_en ( "false"),	//true:gearbox will select loopback data instead of from PMA
	//.test related), 10G prb31), prb9; interlaken:square_wave), hifreq), lofreq.
	  .test_mode ( "test_off"), 			//Valid values: TEST_OFF|PSEUDO_RANDOM|PRBS_31|PRBS_23|PRBS_9|PRBS_7
	//.block sync: 10G and interlaken
	  .blksync_knum_sh_cnt_prelock ( "63"), 	//Valid values: 63      
	  .blksync_knum_sh_cnt_postlock ( "63"),	//Valid values: 63|1023 
	  .blksync_enum_invalid_sh_cnt ( "15"), 	//Valid values: 15|64   
	//.disparity check: interlaken
	//.Descrambler
	//.Frame Sync: interlaken
	  .frmsync_mfrm_length ( 8191), //FRMSYNC_MFRM_LENGTH_MIN), FRMSYNC_MFRM_LENGTH_MAX), FRMSYNC_MFRM_LENGTH_USER_SETTING};
	//.64B/66B Decoder
	  .dec_rx_sm_hiber_en ( "true"),		//true), false	
	//.CRC-32 Checker: Interlaken 
	//.rx fifo
	  .rxfifo_mode ( "clk_comp"),	//Valid values: PHASE_COMP|CLK_COMP|"register_mode"|GENERIC
	  .rxfifo_align_del_en ( "true"),		//true), false	
	  .rxfifo_control_del ( "control_del_none") //Valid values:CONTROL_DEL_ALL), CONTROL_DEL_NONE} ;
)rx_10g_pcs_0
(//input and output port declaration
//	input clklow,
//	input resetn,
	//input tx_pma_clk,
	.clockinfrompma (clk_from_rx_pma),
	.datainfrompma(rx_parallel_data),
//	input rxpmadatavalid,
	.rxpldclk(xgmii_tx_clk),
	.rxpldrstn(rx_digital_rstn),

	.clklow(clklow),
	.fref(fref),
	.freqlock(freqlocked_to_cdr),
	.pmasigdet(signaldetect_from_pma),
//	input [ 0:0 ] refclkdig,
//	input [ 39:0 ] loopbackdatain,
//	input [ 0:0 ] pmaclkdiv33txorrx,
//	input [ 0:0 ] rxalignen,
//	input [ 0:0 ] rxalignclr,
//	input [ 0:0 ] rxrden,
//	input [ 0:0 ] rxdisparityclr,
	.rxclrerrorblockcount(rxclrerrorblockcount),
	.rxclrbercount(rxclrbercount),
	.rxprbserrorclr(rxprbserrorclr),


//	output rx_clockout,
	.rx_freqlock(rx_is_lockedtodata),
	.rx_dataout(rx_dataout),
	.rx_control(rx_control),
	.rx_data_valid(rx_data_valid),

	.bercount(          bercount),
	.errorblockcount(   errorblockcount),
	.pcsstatus(         pcsstatus),
	.randomerrorcount(  randomerrorcount),
	.rxfifoempty(       rxfifoempty),
	.rxfifopartialempty(rxfifopartialempty),
	.rxfifopartialfull( rxfifopartialfull),
	.rxfifofull(        rxfifofull),
	.rxblocklock(       rxblocklock),
	.rxsyncheadererror( rxsyncheadererror),
	.rxhighber(         rxhighber),
	.rxscramblererror   (rxscramblererror)
);
endmodule
